From cb4d7ece332ff77c1a2bfc12f52044395ed82af3 Mon Sep 17 00:00:00 2001
From: Rich Megginson <rmeggins@redhat.com>
Date: Tue, 9 Aug 2011 14:12:35 -0600
Subject: [PATCH] add man pages for ds_removal and ds_unregister

---
 Makefile.am              |    4 ++-
 Makefile.in              |    4 ++-
 man/man8/ds_removal.8    |   54 ++++++++++++++++++++++++++++++++++++++++++++++
 man/man8/ds_unregister.8 |   48 ++++++++++++++++++++++++++++++++++++++++
 4 files changed, 108 insertions(+), 2 deletions(-)
 create mode 100644 man/man8/ds_removal.8
 create mode 100644 man/man8/ds_unregister.8

diff --git a/Makefile.am b/Makefile.am
index 999adc9..792f782 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -246,7 +246,9 @@ perl_DATA = admserv/newinst/src/ASDialogs.pm \
 #------------------------
 # man pages
 #------------------------
-dist_man_MANS = man/man8/migrate-ds-admin.pl.8 \
+dist_man_MANS = man/man8/ds_removal.8 \
+	man/man8/ds_unregister.8 \
+	man/man8/migrate-ds-admin.pl.8 \
 	man/man8/setup-ds-admin.pl.8 \
 	man/man8/start-ds-admin.8 \
 	man/man8/stop-ds-admin.8 \
diff --git a/Makefile.in b/Makefile.in
index 3585ba0..da13e44 100644
--- a/Makefile.in
+++ b/Makefile.in
@@ -657,7 +657,9 @@ perl_DATA = admserv/newinst/src/ASDialogs.pm \
 #------------------------
 # man pages
 #------------------------
-dist_man_MANS = man/man8/migrate-ds-admin.pl.8 \
+dist_man_MANS = man/man8/ds_removal.8 \
+	man/man8/ds_unregister.8 \
+	man/man8/migrate-ds-admin.pl.8 \
 	man/man8/setup-ds-admin.pl.8 \
 	man/man8/start-ds-admin.8 \
 	man/man8/stop-ds-admin.8 \
diff --git a/man/man8/ds_removal.8 b/man/man8/ds_removal.8
new file mode 100644
index 0000000..13824c4
--- /dev/null
+++ b/man/man8/ds_removal.8
@@ -0,0 +1,54 @@
+.\"                                      Hey, EMACS: -*- nroff -*-
+.\" First parameter, NAME, should be all caps
+.\" Second parameter, SECTION, should be 1-8, maybe w/ subsection
+.\" other parameters are allowed: see man(7), man(1)
+.TH DS_REMOVAL 8 "Aug 9, 2011"
+.\" Please adjust this date whenever revising the manpage.
+.\"
+.\" Some roff macros, for reference:
+.\" .nh        disable hyphenation
+.\" .hy        enable hyphenation
+.\" .ad l      left justify
+.\" .ad b      justify to both left and right margins
+.\" .nf        disable filling
+.\" .fi        enable filling
+.\" .br        insert line break
+.\" .sp <n>    insert n+1 empty lines
+.\" for manpage-specific macros, see man(7)
+.SH NAME
+ds_removal \- Remove a directory server instance and un-register it from the console
+.SH SYNOPSIS
+.B ds_removal
+[-f] -s \fIserver_id\fR -w \fIadmin_password\fR
+.SH DESCRIPTION
+Removes the specified Directory Server instance and un-registers it from
+the console.  This will remove all files and directories associated with
+the directory server instance, so if you want to save any data or config,
+back it up first before running this command.
+.PP
+.\" TeX users may be more comfortable with the \fB<whatever>\fP and
+.\" \fI<whatever>\fP escape sequences to invode bold face and italics, 
+.\" respectively.
+.SH OPTIONS
+A summary of options is included below:
+.TP
+.B \fB\-f\fR
+Optional \- Force removal \- ignore errors and remove everything
+.TP
+.B \fB\-s server_id\fR
+Required \- server_id \- the directory server identifier \- slapd\-\fIserver_id\fR
+.TP
+.B \fB\-w password\fR
+Required \- password \- the password for the console admin user
+.br
+.SH AUTHOR
+ds_removal was written by the 389 Project.
+.SH "REPORTING BUGS"
+Report bugs to http://bugzilla.redhat.com.
+.SH COPYRIGHT
+Copyright \(co 2011 Red Hat, Inc.
+.br
+This is free software.  You may redistribute copies of it under the terms of
+the Directory Server license found in the LICENSE file of this
+software distribution.  This license is essentially the GNU General Public
+License version 2 with an exception for plug-in distribution.
diff --git a/man/man8/ds_unregister.8 b/man/man8/ds_unregister.8
new file mode 100644
index 0000000..bfe5f8b
--- /dev/null
+++ b/man/man8/ds_unregister.8
@@ -0,0 +1,48 @@
+.\"                                      Hey, EMACS: -*- nroff -*-
+.\" First parameter, NAME, should be all caps
+.\" Second parameter, SECTION, should be 1-8, maybe w/ subsection
+.\" other parameters are allowed: see man(7), man(1)
+.TH DS_UNREGISTER 8 "Aug 9, 2011"
+.\" Please adjust this date whenever revising the manpage.
+.\"
+.\" Some roff macros, for reference:
+.\" .nh        disable hyphenation
+.\" .hy        enable hyphenation
+.\" .ad l      left justify
+.\" .ad b      justify to both left and right margins
+.\" .nf        disable filling
+.\" .fi        enable filling
+.\" .br        insert line break
+.\" .sp <n>    insert n+1 empty lines
+.\" for manpage-specific macros, see man(7)
+.SH NAME
+ds_unregister \- Un-register a directory server instance from the console
+.SH SYNOPSIS
+.B ds_unregister
+-s \fIserver_id\fR -w \fIadmin_password\fR
+.SH DESCRIPTION
+Un-registers the specified directory server instance from the console.
+.PP
+.\" TeX users may be more comfortable with the \fB<whatever>\fP and
+.\" \fI<whatever>\fP escape sequences to invode bold face and italics, 
+.\" respectively.
+.SH OPTIONS
+A summary of options is included below:
+.TP
+.B \fB\-s server_id\fR
+Required \- server_id \- the directory server identifier \- slapd\-\fIserver_id\fR
+.TP
+.B \fB\-w password\fR
+Required \- password \- the password for the console admin user
+.br
+.SH AUTHOR
+ds_unregister was written by the 389 Project.
+.SH "REPORTING BUGS"
+Report bugs to http://bugzilla.redhat.com.
+.SH COPYRIGHT
+Copyright \(co 2011 Red Hat, Inc.
+.br
+This is free software.  You may redistribute copies of it under the terms of
+the Directory Server license found in the LICENSE file of this
+software distribution.  This license is essentially the GNU General Public
+License version 2 with an exception for plug-in distribution.
-- 
1.7.1