>From 416beda327439da81256b11f70680b735fe78faf Mon Sep 17 00:00:00 2001
From: Jiri Tomasek <jtomasek@redhat.com>
Date: Wed, 23 May 2012 13:44:46 +0200
Subject: [PATCH conductor 01/11] Revert "Revert "Merge branch 'gelato'""

This reverts commit c406ca325092b6ce7f06087556750e65b8037d1f.

Conflicts:

	src/Gemfile.lock
---
 .gitmodules                                        |    3 +++
 src/app/helpers/layout_helper.rb                   |    1 +
 src/app/stylesheets/_converge-ui.scss              |    8 ++++++++
 src/app/stylesheets/layout.scss                    |    1 +
 src/app/views/layouts/application.html.haml        |    2 ++
 .../views/layouts/converge-ui/_header_layout.haml  |    1 +
 .../views/layouts/converge-ui/shell_layout.haml    |    1 +
 src/vendor/converge-ui                             |    1 +
 8 files changed, 18 insertions(+), 0 deletions(-)
 create mode 100644 .gitmodules
 create mode 120000 src/app/helpers/layout_helper.rb
 create mode 100644 src/app/stylesheets/_converge-ui.scss
 create mode 120000 src/app/views/layouts/converge-ui/_header_layout.haml
 create mode 120000 src/app/views/layouts/converge-ui/shell_layout.haml
 create mode 160000 src/vendor/converge-ui

diff --git a/.gitmodules b/.gitmodules
new file mode 100644
index 0000000..c88a242
--- /dev/null
+++ b/.gitmodules
@@ -0,0 +1,3 @@
+[submodule "src/vendor/converge-ui"]
+	path = src/vendor/converge-ui
+	url = git://github.com/Katello/converge-ui.git
diff --git a/src/app/helpers/layout_helper.rb b/src/app/helpers/layout_helper.rb
new file mode 120000
index 0000000..b1e834e
--- /dev/null
+++ b/src/app/helpers/layout_helper.rb
@@ -0,0 +1 @@
+../../vendor/converge-ui/rails/helpers/layout_helper.rb
\ No newline at end of file
diff --git a/src/app/stylesheets/_converge-ui.scss b/src/app/stylesheets/_converge-ui.scss
new file mode 100644
index 0000000..6f21022
--- /dev/null
+++ b/src/app/stylesheets/_converge-ui.scss
@@ -0,0 +1,8 @@
+@import "../../vendor/converge-ui/stylesheets/fonts.scss";
+//@import "../../vendor/converge-ui/stylesheets/footer.scss";
+//@import "../../vendor/converge-ui/stylesheets/forms.scss";
+//@import "../../vendor/converge-ui/stylesheets/header.scss";
+//@import "../../vendor/converge-ui/stylesheets/helpers.scss";
+//@import "../../vendor/converge-ui/stylesheets/media.scss";
+//@import "../../vendor/converge-ui/stylesheets/mixins.scss";
+//@import "../../vendor/converge-ui/stylesheets/shell.scss";
diff --git a/src/app/stylesheets/layout.scss b/src/app/stylesheets/layout.scss
index e121f34..1c440c6 100644
--- a/src/app/stylesheets/layout.scss
+++ b/src/app/stylesheets/layout.scss
@@ -1,4 +1,5 @@
 @import "reset";
+@import "converge-ui";
 @import "mixins";
 @import "helpers";
 @import "fonts";
diff --git a/src/app/views/layouts/application.html.haml b/src/app/views/layouts/application.html.haml
index 991a44b..959629e 100644
--- a/src/app/views/layouts/application.html.haml
+++ b/src/app/views/layouts/application.html.haml
@@ -8,6 +8,7 @@
     %link{:rel =>  'shortcut icon', :href => '/favicon.ico'}
     = stylesheet_link_tag '/stylesheets/compiled/layout.css'
     = stylesheet_link_tag 'jquery.ui-1.8.1/jquery-ui-1.8.1.custom.css'
+    = stylesheet_link_tag '/stylesheets/compiled/header.css'
     /[if lt IE 9]
       = javascript_include_tag 'http://html5shiv.googlecode.com/svn/trunk/html5.js'
     /[if lt IE 8]
@@ -54,6 +55,7 @@
     #content
       = render :partial => '/layouts/new_notification' if flash.present? or content_for?(:error_messages)
       = yield
+      .clear
     %footer.standard
       .container
         %span.copyright!= t('layout.copyright')
diff --git a/src/app/views/layouts/converge-ui/_header_layout.haml b/src/app/views/layouts/converge-ui/_header_layout.haml
new file mode 120000
index 0000000..a322932
--- /dev/null
+++ b/src/app/views/layouts/converge-ui/_header_layout.haml
@@ -0,0 +1 @@
+../../../../vendor/converge-ui/rails/layouts/_header_layout.haml
\ No newline at end of file
diff --git a/src/app/views/layouts/converge-ui/shell_layout.haml b/src/app/views/layouts/converge-ui/shell_layout.haml
new file mode 120000
index 0000000..84edcaf
--- /dev/null
+++ b/src/app/views/layouts/converge-ui/shell_layout.haml
@@ -0,0 +1 @@
+../../../../vendor/converge-ui/rails/layouts/shell_layout.haml
\ No newline at end of file
diff --git a/src/vendor/converge-ui b/src/vendor/converge-ui
new file mode 160000
index 0000000..2e4d138
--- /dev/null
+++ b/src/vendor/converge-ui
@@ -0,0 +1 @@
+Subproject commit 2e4d138bc897243ddb43a9f1ade01d461d21f84a
-- 
1.7.7.6