>From 89adfe6013b1b2c6830b0b353ab7b62c9f554992 Mon Sep 17 00:00:00 2001
From: Mike Orazi <morazi@redhat.com>
Date: Thu, 19 May 2011 19:12:32 -0400
Subject: [PATCH configure 1/1] Add conf directory with yml

---
 conf/README            |   13 +++++++++++++
 conf/default_cleanup   |   16 ++++++++++++++++
 conf/default_configure |   23 +++++++++++++++++++++++
 conf/iwhd_cleanup      |   12 ++++++++++++
 conf/iwhd_configure    |   19 +++++++++++++++++++
 5 files changed, 83 insertions(+), 0 deletions(-)
 create mode 100644 conf/README
 create mode 100644 conf/default_cleanup
 create mode 100644 conf/default_configure
 create mode 100644 conf/iwhd_cleanup
 create mode 100644 conf/iwhd_configure

diff --git a/conf/README b/conf/README
new file mode 100644
index 0000000..832c568
--- /dev/null
+++ b/conf/README
@@ -0,0 +1,13 @@
+This directory contains a pair of default_ yml files to describe
+a fully configured aeolus-conductor w/ all of required subcomponents
+on a single box.
+
+Additionally, the iwhd pair of files demonstrates how one could install
+only select components on a particular box (for this to be located correctly
+it should be renamed to <fqdn>_cleanup & <fqdn>_configure respectively.
+Doing so will override the default 'configure everything' description though.
+
+IMPORTANT NOTE:  https is on by default, but no other security is in place
+to ensure that components on different machines can interact in a secure
+fashion.  This is on the roadmap, but not currently in place.  Segregate
+services at your own risk.
diff --git a/conf/default_cleanup b/conf/default_cleanup
new file mode 100644
index 0000000..36f3521
--- /dev/null
+++ b/conf/default_cleanup
@@ -0,0 +1,16 @@
+#Default cleanup specification
+
+#Set everything up on this box.
+#You can override the default behavior
+#by creating <fqdn>_cleanup with the
+#class membership and parameters as
+#desire and it will take precedence over this.
+---
+parameters:
+  enable_https: true
+  enable_security: false
+classes:
+- aeolus::conductor::disabled
+- aeolus::iwhd::disabled
+- aeolus::image-factory::disabled
+- aeolus::conductor::remove_seed_data
diff --git a/conf/default_configure b/conf/default_configure
new file mode 100644
index 0000000..fb89277
--- /dev/null
+++ b/conf/default_configure
@@ -0,0 +1,23 @@
+#Default setup configuration.
+
+#Set everything up on this box.
+#You can override the default behavior
+#by creating <fqdn>_configure with the
+#class membership and parameters as
+#desire and it will take precedence over this.
+
+#NOTE:  Although this suggests the components
+#can be deployed on individual boxes.  This will likely
+#become a common practice, but be advised that currently
+#apart from https on the web server for conductor, you should
+#consider intermachine communications insecure.  Securing
+#intermachine service calls is on the roadmap.
+---
+parameters:
+  enable_https: true
+  enable_security: false
+classes:
+- aeolus::conductor
+- aeolus::image-factory
+- aeolus::iwhd
+- aeolus::conductor::seed_data
diff --git a/conf/iwhd_cleanup b/conf/iwhd_cleanup
new file mode 100644
index 0000000..5f7a595
--- /dev/null
+++ b/conf/iwhd_cleanup
@@ -0,0 +1,12 @@
+#iwhd-only cleanup specification
+
+#You can override the default behavior
+#by renaming this to  <fqdn>_cleanup.
+#This will result in only iwhd being
+#disabled
+---
+parameters:
+  enable_https: true
+  enable_security: false
+classes:
+- aeolus::iwhd::disabled
diff --git a/conf/iwhd_configure b/conf/iwhd_configure
new file mode 100644
index 0000000..5ed3b92
--- /dev/null
+++ b/conf/iwhd_configure
@@ -0,0 +1,19 @@
+#iwhd-only setup configuration.
+
+#renaming this file to <fqdn>_configure will
+#make it override the default configure everything
+#behavior with the behavior below to only set up
+#iwhd
+
+#NOTE:  Although this suggests the components
+#can be deployed on individual boxes.  This will likely
+#become a common practice, but be advised that currently
+#apart from https on the web server for conductor, you should
+#consider intermachine communications insecure.  Securing
+#intermachine service calls is on the roadmap.
+---
+parameters:
+  enable_https: true
+  enable_security: false
+classes:
+- aeolus::iwhd
-- 
1.7.4.4